//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     DeepPink
#property indicator_color3     Gold
#property indicator_width1     2
#property indicator_width2     2
#property indicator_style3     STYLE_DASH

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame   = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE Price       = PRICE_CLOSE;
extern double             ItPeriod    = 20;
extern ENUM_MA_METHOD     MaMethod    = MODE_EMA;
extern int                LevelBars   = 300;
extern double             LevelFactor = 0.283;

extern string _               = "alerts settings";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Upval[];
double Dnval[];
double ItLev[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
      IndicatorBuffers(4);
      SetIndexBuffer(0,Upval); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Dnval); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ItLev);
      SetIndexBuffer(3,trend);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame==-99);
      TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(TimeFrame)+"  ITrend ");
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Upval[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
    
      for (int i=limit-1; i>=0; i--)
      {  
         double ma = iMA(NULL,0,1,0,MaMethod,Price,i);
         Upval[i]  = ma        - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i);
         Dnval[i]  = - (Low[i] - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i)
                     +  High[i]- iMA(NULL,0,ItPeriod,0,MaMethod,Price,i));
                     
         double hi = MathMax(Upval[ArrayMaximum(Upval,LevelBars,i)],Dnval[ArrayMaximum(Dnval,LevelBars,i)]);
         ItLev[i]  = hi*LevelFactor; 
         trend[i]  = trend[i+1]; 
         
	      if (Upval[i] > ItLev[i]) trend[i]= 1; 
	      if (Dnval[i] > ItLev[i]) trend[i]=-1;
       }  
   
       SetLevelValue(0,ItLev[0]);
       manageAlerts();
     return(0);
    }

    //
    //
    //
    //
    //
  
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
            Upval[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,Price,ItPeriod,MaMethod,LevelBars,LevelFactor,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
            Dnval[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,Price,ItPeriod,MaMethod,LevelBars,LevelFactor,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
            ItLev[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,Price,ItPeriod,MaMethod,LevelBars,LevelFactor,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
            trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,0,Price,ItPeriod,MaMethod,LevelBars,LevelFactor,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
    }   
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(_Period)+"  Itrend ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  Itrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


